
package de.ivu.elect.presentation.gebietsbaum.action;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.gebietsbaum.boundary.GebietExtendedDAO;
import de.ivu.elect.business.gebietsbaum.entity.Gebietsart;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.gebietsbaum.GebietsartenAnpassbar;

@Named(GebietsartDeleteAction.COMPONENT_NAME)
public class GebietsartDeleteAction extends AbstractGebietsartAction {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gebietsartDeleteAction";

  @Inject
  private transient GebietExtendedDAO gebietExtendedDAO;

  @Inject
  private transient GebietsartenAnpassbar gebietsartenAnpassbar;

  public GebietsartDeleteAction() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.GEBIETSART_DELETE;
  }

  @Override
  protected boolean isDisabledInternal(@Nonnull Gebietsart gebietsart) {
    return super.isDisabledInternal(gebietsart) || !gebietsart.getBezirksart().isKeine() || !gebietsartenAnpassbar
        .isGebietsartenErweiterbar() || isGebietVorhanden(gebietsart);
  }

  private boolean isGebietVorhanden(Gebietsart gebietsart) {
    return gebietExtendedDAO.findByCountGebieteByGebietsart(gebietsart) > 0;
  }

  @Override
  protected boolean isFireChangeEvent() {
    return true;
  }

  @Nullable
  @Override
  protected String doIt(Gebietsart entity) {
    conversationSelect.setEntity(entity);

    // Return to current page and display the dialog!
    return null;
  }

  @Override
  public String getDialogName() {
    return "DeleteConfirm";
  }

  @Override
  public String getLabelKey() {
    return "entity.edit.action.delete";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconDelete();
  }
}
